package com.jln.system.web.action.mqtt;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.TypeReference;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.google.gson.JsonObject;
import com.jln.common.utils.EmptyUtil;
import com.jln.system.web.action.mqtt.pojo.dto.JsonDataDto;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.data.domain.Sort;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.stereotype.Component;
import org.springframework.util.ObjectUtils;
import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.util.*;

@Slf4j
@Component
public class Base64decrypt {

    @Autowired
    private MongoTemplate mongoTemplate;

    @Value("${jugeTime}")
    private Long jugeTime;

    @Value("${sleepTime}")
    private Long sleepTime;

    private Map<String,Object> findMongo( Map<String,Set<Map<String,Object>>> tableFiels ) {
        DateTimeFormatter fmDate = DateTimeFormatter.ofPattern("yyyyMM");
        String yearMonth = LocalDate.now().format(fmDate);
        Map<String,Object> map = new HashMap<>();
        for (Map.Entry<String, Set<Map<String, Object>>> stringSetEntry : tableFiels.entrySet()) {
            Query query = new Query();
            Map<String,String> mapper = new HashMap<>();
            for (Map<String, Object> stringStringMap : stringSetEntry.getValue()) {
                for (String s : stringStringMap.keySet()) {
                    query.fields().include(s);
                    mapper.put(s,stringStringMap.get(s).toString());
                }
            }

            query.fields().include("time");
            query.limit(1);
            query.with(Sort.by(
                    Sort.Order.desc("time")
            ));

            List<JSONObject> objectList = mongoTemplate.find(query, JSONObject.class, stringSetEntry.getKey()+yearMonth);
            //mongdb最新数据时间
            Map<String ,Object> map1 = objectList.get(0).toJavaObject(Map.class);
            for (Map.Entry<String, Object> stringObjectEntry : map1.entrySet()) {
                map.put(mapper.get(stringObjectEntry.getKey()),stringObjectEntry.getValue());
            }
        }
        map.remove(null);
       return  map;
    }

   /* private Map findMongo1(String deviceId,int start,int end) {
        int i = (int)Math.ceil((double) start/50);
        int j =(int) Math.ceil((double) end/50);

        System.out.println();
        String tableName = "";
        Map map = null;
        DateTimeFormatter fmDate = DateTimeFormatter.ofPattern("yyyyMM");
        String yearMonth = LocalDate.now().format(fmDate);
        for(int x = i; x<=j; x++){
            try {
                if(x<10){
                    tableName = deviceId + "0" +x + yearMonth;
                }else{
                    tableName = deviceId + x + yearMonth;
                }
                //从mongodb查询
                Query query = new Query();
                query.limit(1);
                query.with(Sort.by(
                        Sort.Order.desc("time")
                ));
                if(x==j){
                    for (int a=start;a<=end;a++){
                        query.fields().include("d"+a);
                    }
                }else{
                    for (int a=start;a<=x*50;a++){
                        query.fields().include("d"+a);
                    }
                }
                query.fields().include("time");
                List<JSONObject> objectList = mongoTemplate.find(query, JSONObject.class, tableName);
                //mongdb最新数据时间
                Long time = Long.valueOf(objectList.get(0).toJavaObject(Map.class).get("time").toString());
                //当前时间
                long millis = Calendar.getInstance().getTimeInMillis();
                //如果当前时间-最新上报数据的时间<设置关机范围，那么直接给
                if ((millis - time) < jugeTime && !ObjectUtils.isEmpty(objectList)) {
                    JSONObject jsonObject = objectList.get(0);
                    if(!EmptyUtil.isEmpty(map)){
                        map.putAll(jsonObject.toJavaObject(Map.class));
                    }else{
                        map = jsonObject.toJavaObject(Map.class);
                    }
                }
            } catch (Exception e) {
                return map;
            }
        }
        return map;
    }*/

    /**
     * 机器人测试
     */
    public Map<String, Object> jqrSendString(JsonDataDto jsonDataDto, Map<String, Object> objectMap, long millis, Map<String, Object> reportDto) {
        Map<String, Object> mongoMap = findMongo(jsonDataDto.getTableFiels());
        mongoMap.forEach((key,value)->{
            if(key.equals("Status")){
                if(EmptyUtil.isEmpty(value) || "0".equals(value)){
                    mongoMap.put(key,4);
                }
            }
        });
        mongoMap.putAll(objectMap);
         millis = Calendar.getInstance().getTimeInMillis();
        //处理实体类在每个字段加上时间
        List<Map<String, Object>> allDto = new ArrayList<>();
        Map<String,Object> sites = new HashMap<>();
        for (Map.Entry<String, Object> stringObjectEntry : objectMap.entrySet()) {
            Map<String,Object> properites = new HashMap<>();
            properites.put(stringObjectEntry.getKey(),stringObjectEntry.getValue());
            properites.put("ts",millis);
            allDto.add(properites);
        }
        try{
            Map<String,Object> treeMap = new HashMap<>();
            for (Map<String, Object> stringObjectMap : jsonDataDto.getTree()) {
                //循环key
                Set<Map.Entry<String, Object>> entrySet = stringObjectMap.entrySet();
                for (Map.Entry<String, Object> stringObjectEntry : entrySet) {
                    String value = JSON.toJSONString(stringObjectEntry.getValue());
                    try{
                        JSONObject jsonObject = JSONObject.parseObject(value);
                        Map<String,Object> keyValue = new HashMap<>();
                        for (Map.Entry<String, Object> objectEntry : jsonObject.entrySet()) {
                            keyValue.put(String.valueOf(objectEntry.getValue()),mongoMap.get(objectEntry.getValue()));
                        }
                        treeMap.put(stringObjectEntry.getKey(),keyValue);
                    }catch (Exception e){
                        Map<String,Object> keyValue = new HashMap<>();
                        keyValue.put(String.valueOf(stringObjectEntry.getValue()),mongoMap.get(stringObjectEntry.getValue()));
                        keyValue.put("ts",millis);
                        allDto.add(keyValue);
                    }
                }
            }
            allDto.add(treeMap);
        }catch (Exception e){
            System.out.println(e);
            Map<String, Object> site = new HashMap<>();
            site.put("Status", "2");
            site.put("ts", millis);
            allDto.add(site);
            reportDto.put("reported", allDto);
            reportDto.put("edgeTime", millis);
            return reportDto;
        }

        reportDto.put("reported", allDto);

        JSONObject jsonObj=new JSONObject(reportDto);
        String s =jsonObj.toString();
        String str = JSONObject.toJSONString(jsonObj, SerializerFeature.WriteMapNullValue);
        System.out.println("輸出Json:"+str);
        return reportDto;
    }

}
